Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_scatter.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_scatter.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_scatter.cpp	(revision 1539)
@@ -42,8 +42,6 @@
   int MPI_Scatter(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm)
   {
-    if(!comm->is_ep)
-    {
-      return ::MPI_Scatter(sendbuf, sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), root, to_mpi_comm(comm->mpi_comm));
-    }
+    if(!comm->is_ep) return ::MPI_Scatter(sendbuf, sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), root, to_mpi_comm(comm->mpi_comm));
+    if(comm->is_intercomm) return MPI_Scatter_intercomm(sendbuf, sendcount, sendtype, recvbuf, recvcount, recvtype, root, comm);
    
     assert(sendcount == recvcount);
@@ -97,8 +95,4 @@
 
 
-
-    // if(is_root) printf("\nranks = %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n", ranks[0], ranks[1], ranks[2], ranks[3], ranks[4], ranks[5], ranks[6], ranks[7], 
-    //                                                                                   ranks[8], ranks[9], ranks[10], ranks[11], ranks[12], ranks[13], ranks[14], ranks[15]);
-
     if(is_root)
     for(int i=0; i<ep_size; i++)
@@ -106,10 +100,4 @@
       memcpy(tmp_sendbuf + i*datasize*count, sendbuf + ranks[i]*datasize*count, count*datasize);
     }
-
-    // if(is_root) printf("\ntmp_sendbuf = %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n", static_cast<int*>(tmp_sendbuf)[0], static_cast<int*>(tmp_sendbuf)[2], static_cast<int*>(tmp_sendbuf)[4], static_cast<int*>(tmp_sendbuf)[6], 
-    //                                                                           static_cast<int*>(tmp_sendbuf)[8], static_cast<int*>(tmp_sendbuf)[10], static_cast<int*>(tmp_sendbuf)[12], static_cast<int*>(tmp_sendbuf)[14], 
-    //                                                                           static_cast<int*>(tmp_sendbuf)[16], static_cast<int*>(tmp_sendbuf)[18], static_cast<int*>(tmp_sendbuf)[20], static_cast<int*>(tmp_sendbuf)[22], 
-    //                                                                           static_cast<int*>(tmp_sendbuf)[24], static_cast<int*>(tmp_sendbuf)[26], static_cast<int*>(tmp_sendbuf)[28], static_cast<int*>(tmp_sendbuf)[30] );
-
 
     // MPI_Scatterv from root to masters
@@ -127,6 +115,4 @@
       ::MPI_Scatterv(tmp_sendbuf, recvcounts.data(), displs.data(), to_mpi_type(sendtype), local_recvbuf, num_ep*count, to_mpi_type(recvtype), root_mpi_rank, to_mpi_comm(comm->mpi_comm));
 
-      // printf("local_recvbuf = %d %d %d %d\n", static_cast<int*>(local_recvbuf)[0], static_cast<int*>(local_recvbuf)[1], static_cast<int*>(local_recvbuf)[2], static_cast<int*>(local_recvbuf)[3]);
-                                                          // static_cast<int*>(local_recvbuf)[4], static_cast<int*>(local_recvbuf)[5], static_cast<int*>(local_recvbuf)[6], static_cast<int*>(local_recvbuf)[7]);
     }
 
@@ -138,3 +124,10 @@
   }
 
+
+  int MPI_Scatter_intercomm(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm)
+  {
+    printf("MPI_Scatter_intercomm not yet implemented\n");
+    MPI_Abort(comm, 0);
+  }
+
 }
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_scatterv.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_scatterv.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_scatterv.cpp	(revision 1539)
@@ -45,8 +45,6 @@
                    MPI_Datatype recvtype, int root, MPI_Comm comm)
   {
-    if(!comm->is_ep)
-    {
-      return ::MPI_Scatterv(sendbuf, sendcounts, displs, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), root, to_mpi_comm(comm->mpi_comm));
-    }
+    if(!comm->is_ep) return ::MPI_Scatterv(sendbuf, sendcounts, displs, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), root, to_mpi_comm(comm->mpi_comm));
+    if(comm->is_intercomm) return MPI_Scatterv_intercomm(sendbuf, sendcounts, displs, sendtype, recvbuf, recvcount, recvtype, root, comm);
    
     assert(sendtype == recvtype);
@@ -105,10 +103,7 @@
       for(int i=0; i<ep_size; i++)
       {
-        //printf("i=%d : start from %d, src displs = %d, count = %d\n ", i, local_displs/datasize, displs[ranks[i]], sendcounts[ranks[i]]);
         memcpy(tmp_sendbuf+local_displs, sendbuf + displs[ranks[i]]*datasize, sendcounts[ranks[i]]*datasize);
         local_displs += sendcounts[ranks[i]]*datasize;
       }
-      
-      //for(int i=0; i<ep_size*2; i++) printf("%d\t", static_cast<int*>(const_cast<void*>(tmp_sendbuf))[i]);
     }
 
@@ -129,9 +124,4 @@
 
       ::MPI_Scatterv(tmp_sendbuf, recvcounts.data(), my_displs.data(), to_mpi_type(sendtype), local_sendbuf, num_ep*count, to_mpi_type(recvtype), root_mpi_rank, to_mpi_comm(comm->mpi_comm));
-
-      // printf("my_displs = %d %d %d %d\n", my_displs[0], my_displs[1], my_displs[2], my_displs[3] );
-
-      // printf("%d %d %d %d %d %d %d %d\n", static_cast<int*>(local_sendbuf)[0], static_cast<int*>(local_sendbuf)[1], static_cast<int*>(local_sendbuf)[2], static_cast<int*>(local_sendbuf)[3],
-      //                                     static_cast<int*>(local_sendbuf)[4], static_cast<int*>(local_sendbuf)[5], static_cast<int*>(local_sendbuf)[6], static_cast<int*>(local_sendbuf)[7]);
     }
 
@@ -154,3 +144,11 @@
 
 
+  int MPI_Scatterv_intercomm(const void *sendbuf, const int sendcounts[], const int displs[], MPI_Datatype sendtype, void *recvbuf, int recvcount,
+                   MPI_Datatype recvtype, int root, MPI_Comm comm)
+  {
+    printf("MPI_Scatterv_intercomm not yet implemented\n");
+    MPI_Abort(comm, 0);
+  }
+
+
 }
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_send.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_send.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_send.cpp	(revision 1539)
@@ -18,5 +18,5 @@
   {
     if(!comm->is_ep)       return MPI_Send_mpi(buf, count, datatype, dest, tag, comm);
-    if(comm->is_intercomm) return MPI_Send_intercomm(buf, count, datatype, dest, tag, comm);
+    if(comm->is_intercomm) dest = comm->inter_rank_map->at(dest);
     
     Debug("\nMPI_Send with EP\n");
@@ -38,5 +38,5 @@
   {
     if(!comm->is_ep)       return MPI_Ssend_mpi(buf, count, datatype, dest, tag, comm);
-    if(comm->is_intercomm) return MPI_Ssend_intercomm(buf, count, datatype, dest, tag, comm);
+    if(comm->is_intercomm) dest = comm->inter_rank_map->at(dest);
     
     Debug("\nMPI_Ssend with EP\n");
@@ -61,5 +61,5 @@
   {
     if(!comm->is_ep)       return MPI_Isend_mpi(buf, count, datatype, dest, tag, comm, request);
-    if(comm->is_intercomm) return MPI_Isend_intercomm(buf, count, datatype, dest, tag, comm, request);
+    if(comm->is_intercomm) dest = comm->inter_rank_map->at(dest);
 
     Debug("\nMPI_Isend with EP\n");
@@ -104,5 +104,5 @@
  
     if(!comm->is_ep) return MPI_Issend_mpi(buf, count, datatype, dest, tag, comm, request);
-    if(comm->is_intercomm) return MPI_Issend_intercomm(buf, count, datatype, dest, tag, comm, request);
+    if(comm->is_intercomm) dest = comm->inter_rank_map->at(dest);
 
     Debug("\nMPI_Issend with EP\n");
@@ -144,15 +144,5 @@
     return ::MPI_Send(buf, count, to_mpi_type(datatype), dest, tag, to_mpi_comm(comm->mpi_comm));
   }
-  
-  int MPI_Send_intercomm(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm)
-  {
-    Debug("\nMPI_Send_intercomm with EP\n");
-    MPI_Request request;
-    MPI_Status status;
-    MPI_Isend(buf, count, datatype, dest, tag, comm, &request);
-    MPI_Wait(&request, &status);
-    return MPI_SUCCESS;
-  }
-  
+ 
   
   int MPI_Ssend_mpi(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm)
@@ -163,14 +153,4 @@
   
 
-  int MPI_Ssend_intercomm(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm)
-  {
-    Debug("\nMPI_Ssend_intercomm with EP\n");
-    MPI_Request request;
-    MPI_Status status;
-    MPI_Issend(buf, count, datatype, dest, tag, comm, &request);
-    MPI_Wait(&request, &status);
-    return MPI_SUCCESS;
-  }
-  
   int MPI_Isend_mpi(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
   {
@@ -195,59 +175,5 @@
   }
   
-  int MPI_Isend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
-  {
-    Debug("\nMPI_Isend_intercomm with EP\n");
-
-#ifdef _check_sum    
-    check_sum_send(buf, count, datatype, dest, tag, comm);
-#endif
-
-    int src_comm_label  = comm->ep_comm_ptr->comm_label;
-    int dest_comm_label = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest).second.second;
-    
-    int src_rank;
-    MPI_Comm_rank(comm, &src_rank);
-
-    
-    *request = new ep_request;
-    memcheck("new "<< *request <<" : in ep_lib::MPI_Isend_intercomm, *request = new ep_request");
-
-    (*request)->mpi_request = new ::MPI_Request;
-    memcheck("new "<< (*request)->mpi_request <<" : in ep_lib::MPI_Isend_intercomm, (*request)->mpi_request = new ::MPI_Request");
-    
-
-    int ep_src_loc  = comm->ep_rank_map->at(src_rank).first;
-    int ep_dest_loc = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest).first;
-    int mpi_tag     = tag_combine(tag, ep_src_loc, ep_dest_loc);
-    int mpi_dest    = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest).second.first;
-
-#ifdef _showinfo
-    printf("Send : ep_src_loc = %d, ep_dest_loc = %d, mpi_src = %d, mpi_dest = %d, mpi_tag = %d\n", ep_src_loc, ep_dest_loc, comm->ep_comm_ptr->size_rank_info[2].first, mpi_dest, mpi_tag);
-#endif
-    
-
-    (*request)->ep_src  = src_rank;
-    (*request)->ep_tag  = tag;
-    (*request)->ep_datatype = datatype;
-
-    (*request)->type = 1;    // used in wait
-    (*request)->comm = comm;
-    (*request)->buf = const_cast<void*>(buf);
-
-
-    if(src_comm_label == dest_comm_label)
-    {
-      Debug("\nMPI_Isend_intercomm with EP_intracomm\n");
-      return ::MPI_Isend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm->mpi_comm), to_mpi_request_ptr(*request));
-    }
-
-    else
-    {
-      Debug("\nMPI_Isend_intercomm with EP_intercomm\n");
-      return ::MPI_Isend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm->ep_comm_ptr->intercomm->mpi_inter_comm), to_mpi_request_ptr(*request));
-    }
-  }
-
-
+  
 
 
@@ -275,57 +201,4 @@
 
 
-  int MPI_Issend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
-  {
-    Debug("\nMPI_Issend_intercomm with EP\n");
-
-#ifdef _check_sum    
-    check_sum_send(buf, count, datatype, dest, tag, comm);
-#endif
-
-    int src_comm_label  = comm->ep_comm_ptr->comm_label;
-    int dest_comm_label = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest).second.second;
-    
-    int src_rank;
-    MPI_Comm_rank(comm, &src_rank);
-
-    
-    *request = new ep_request;
-    memcheck("new "<< *request <<" : in ep_lib::MPI_Issend_intercomm, *request = new ep_request");
-
-    (*request)->mpi_request = new ::MPI_Request;
-    memcheck("new "<< (*request)->mpi_request <<" : in ep_lib::MPI_Issend_intercomm, (*request)->mpi_request = new ::MPI_Request");
-    
-
-    int ep_src_loc  = comm->ep_rank_map->at(src_rank).first;
-    int ep_dest_loc = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest).first;
-    int mpi_tag     = tag_combine(tag, ep_src_loc, ep_dest_loc);
-    int mpi_dest    = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest).second.first;
-
-#ifdef _showinfo
-    printf("ep_src_loc = %d, ep_dest_loc = %d, mpi_src = %d, mpi_dest = %d, mpi_tag = %d\n", ep_src_loc, ep_dest_loc, comm->ep_comm_ptr->size_rank_info[2].first, mpi_dest, mpi_tag);
-#endif
-    
-    (*request)->ep_src  = src_rank;
-    (*request)->ep_tag  = tag;
-    (*request)->ep_datatype = datatype;
-
-    (*request)->type = 1;    // used in wait
-    (*request)->comm = comm;
-    (*request)->buf = const_cast<void*>(buf);
-
-
-    if(src_comm_label == dest_comm_label)
-    {
-      Debug("\nMPI_Issend_intercomm with EP_intracomm\n");
-      return ::MPI_Issend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm->mpi_comm), to_mpi_request_ptr(*request));
-    }
-
-    else
-    {
-      Debug("\nMPI_Issend_intercomm with EP_intercomm\n");
-      return ::MPI_Issend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm->ep_comm_ptr->intercomm->mpi_inter_comm), to_mpi_request_ptr(*request));
-    }
-  }
-  
 }
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_size.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_size.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_size.cpp	(revision 1539)
@@ -22,14 +22,5 @@
     if(comm->is_ep)
     {
-      if(comm->is_intercomm)
-      {
-        Debug("MPI_Comm_remote_size with EP_intercomm");
-        return *size = comm->ep_comm_ptr->intercomm->intercomm_rank_map->size();
-      }
-      else
-      {
-        Debug("MPI_Comm_remote_size with EP_intracomm");
-        return *size=0;
-      }
+      return *size = comm->is_intercomm? comm->inter_rank_map->size() : 0;
     }
     return MPI_Comm_remote_size_mpi(comm, size);
@@ -49,5 +40,4 @@
   }
 
-
 }
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_split.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_split.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_split.cpp	(revision 1539)
@@ -9,27 +9,4 @@
 {
 
-  void vec_simplify(std::vector<int> *inout_vector)
-  {
-    std::vector<int> out_vec;
-    int found=false;
-    for(std::vector<int>::iterator it_in = inout_vector->begin() ; it_in != inout_vector->end(); ++it_in)
-    {
-      for(std::vector<int>::iterator it = out_vec.begin() ; it != out_vec.end(); ++it)
-      {
-        if(*it_in == *it)
-        {
-          found=true;
-          break;
-        }
-        else found=false;
-      }
-      if(found == false)
-      {
-        out_vec.push_back(*it_in);
-      }
-    }
-    inout_vector->swap(out_vec);
-  }
-  
   void vec_simplify(std::vector<int> *in_vector, std::vector<int> *out_vector)
   {
@@ -274,6 +251,4 @@
         *newcomm = comm->ep_comm_ptr->comm_list[0]->mem_bridge[new_ep_rank_loc];
         memcheck("in MPI_Split ep_rank="<< ep_rank <<" : *newcomm = "<< *newcomm);
-
-        (*newcomm)->ep_comm_ptr->comm_label = color;
         
         (*newcomm)->ep_comm_ptr->size_rank_info[0].first = new_ep_rank;
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.cpp	(revision 1539)
@@ -33,35 +33,4 @@
   }
 
-  /*
-  
-  MPI_Aint::MPI_Aint(void* aint)
-  {
-    mpi_aint = new ::MPI_Aint;
-    *(static_cast< ::MPI_Aint*>(mpi_aint)) = *(static_cast< ::MPI_Aint*>(aint));
-  }
-
-  MPI_Aint::MPI_Aint(int aint)
-  {
-    mpi_aint = new ::MPI_Aint;
-    *(static_cast< ::MPI_Aint*>(mpi_aint)) = aint;
-  }
-
-  MPI_Aint MPI_Aint::operator=(int a)
-  {
-    mpi_aint = new ::MPI_Aint;
-    *(static_cast< int*>(mpi_aint)) = a; 
-  }
-  
-  MPI_Fint::MPI_Fint(void* fint)
-  {
-    mpi_fint = new ::MPI_Fint;
-    *(static_cast< ::MPI_Fint*>(mpi_fint)) = *(static_cast< ::MPI_Fint*>(fint));
-  }
-
-  
-*/
-  
-
-
 }
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.hpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.hpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.hpp	(revision 1539)
@@ -38,5 +38,4 @@
 #include "ep_barrier.hpp"
 #include "ep_comm.hpp"
-#include "ep_intercomm.hpp"
 #include "ep_window.hpp"
 
@@ -86,4 +85,6 @@
   static std::map<std::pair<int, int>, MPI_Comm >  fc_comm_map;
 
+  
+
 
 }
